#!/bin/sh
#Script to make DirectFB by Yan Wang in MediaTek

if [ true ]; then
#link the BDP_Generic/src/diver/inc/x_gfx_mt85_comm.h to DirectFB-1.2.7/systems/mtk/x_gfx_mt85_comm.h
#ln -snf ../../../../../BDP_Generic/src/diver/inc/x_gfx_mt85_comm.h ./systems/mtk/x_gfx_mt85_comm.h

#add by maozhong
   if [ "`grep -w mt8580 $(pwd)/../../../../../BDP_Generic/build/configuration`" != "" ]; then
        INSTALL_TAR_NAME=DirectFB-1.2.7-vfp-cortexA9-install.tar.bz2
   fi
   
   if [ "`grep -w mt8560 $(pwd)/../../../../../BDP_Generic/build/configuration`" != "" ] || [ "`grep -w mt8551 $(pwd)/../../../../../BDP_Generic/build/configuration`" != "" ]; then
        INSTALL_TAR_NAME=DirectFB-1.2.7-vfp-arm11-install.tar.bz2
   fi
     
   if [ "`grep -w mt8561 $(pwd)/../../../../../BDP_Generic/build/configuration`" != "" ] || [ "`grep -w mt8552 $(pwd)/../../../../../BDP_Generic/build/configuration`" != "" ]; then
        INSTALL_TAR_NAME=DirectFB-1.2.7-soft-arm11-install.tar.bz2
   fi
 
    echo -e "\033[40;31mDirectFB Dynamic Library Will Build\033[0m" 

	export DEST_DIR=$(pwd)/../../../build/DirectFB/DirectFB-1.2.7

	touch install_flag

#	exit $MAKE_RET

	export LDFLAGS="-L$(pwd)/../../../../../BDP_Generic/build/sysroot/lib \
	                -L$(pwd)/../../../../../BDP_Generic/build/sysroot/usr/lib $LDFLAGS"
	                	                
	export CFLAGS="$CFLAGS -fPIC -g -fexceptions  \
	                -DCONFIG_CHIP_VER_CURR=8580 \
	                -DCONFIG_CHIP_VER_MT8555=8555 \
	                -DCONFIG_CHIP_VER_MT8560=8560 \
	                -DCONFIG_CHIP_VER_MT8580=8580 \
	                -DCONFIG_CHIP_VER_MT8561=8561 \
	                -DCONIFG_MTK_DFB_DYNAMIC_LOAD_FUSION=0 \
	                -I$(pwd)/../../../../../BDP_Generic/build/sysroot/usr/include"
	make clean
	make distclean

	if test -z "${CROSS_COMPILE}"; then
		CROSS_COMPILE=armv7a-mediatek451_001_vfp-linux-gnueabi-
	fi

	./configure \
	--prefix=/usr \
	--exec-prefix=/ \
	--host=armv7a-mediatek451_001_vfp-linux-gnueabi \
	--enable-debug=no \
	--enable-multi \
	--enable-x11=no \
	--enable-osx=no \
	--enable-voodoo=no \
	--enable-mmx=no \
	--enable-sse=no \
	--enable-devmem=no \
	--enable-fbdev=no \
	--enable-mtk \
	--enable-jpeg \
	--enable-png \
	--enable-gif \
	--enable-freetype \
	--enable-video4linux=no \
	--with-gfxdrivers=mt85 \
	--with-tools \
	--with-inputdrivers=lirc,keyboard,ps2mouse \
	--without-smooth-scaling

	make -j64
	make DESTDIR=${DEST_DIR} install

	MAKE_RET=$?
	if [ $MAKE_RET -ne 0 ]; then
	   echo -e "\033[40;31mDirectFB Dynamic Library Build Fail......($MAKE_RET)\033[0m"
	   exit $MAKE_RET
	else
	    echo -e "\033[40;32mDirectFB Dynamic Library Build Success\033[0m"
	fi

#mtk40438 add
STATIC_LIBRARY=YES

if [ "$1" = "-dynamic" ]; then
    shift
    echo "Only build dynamic library!!"
    STATIC_LIBRARY=
fi

if [ -n "${STATIC_LIBRARY}" ]; then
        echo -e "\033[40;31mDirectFB Static Library Will Build\033[0m"

	export DEST_DIR_STATIC=$(pwd)/../../../build/DirectFB/DirectFB-1.2.7_static

	touch install_flag

	export LDFLAGS="-L$(pwd)/../../../../../BDP_Generic/build/sysroot/lib \
	                -L$(pwd)/../../../../../BDP_Generic/build/sysroot/usr/lib $LDFLAGS"
	                
	                
	export CFLAGS="$CFLAGS -fPIC -g -fexceptions -DMTK_DFB_STATIC \
	                -DCONFIG_CHIP_VER_CURR=8580 \
	                -DCONFIG_CHIP_VER_MT8555=8555 \
	                -DCONFIG_CHIP_VER_MT8560=8560 \
	                -DCONFIG_CHIP_VER_MT8580=8580 \
	                -DCONFIG_CHIP_VER_MT8561=8561 \
	                -DCONIFG_MTK_DFB_DYNAMIC_LOAD_FUSION=0 \
	                -I$(pwd)/../../../../../BDP_Generic/build/sysroot/usr/include"
	                
	make clean
	make distclean

	if test -z "${CROSS_COMPILE}"; then
		CROSS_COMPILE=armv7a-mediatek451_001_vfp-linux-gnueabi-
	fi

	./configure \
	--prefix=/usr \
	--exec-prefix=/ \
	--host=armv7a-mediatek451_001_vfp-linux-gnueabi \
	--enable-debug=no \
	--enable-multi \
	--enable-x11=no \
	--enable-osx=no \
	--enable-voodoo=no \
	--enable-mmx=no \
	--enable-sse=no \
	--enable-devmem=no \
	--enable-fbdev=no \
	--enable-mtk \
	--enable-jpeg \
	--enable-png \
	--enable-gif \
	--enable-freetype \
	--enable-video4linux=no \
	--with-gfxdrivers=mt85 \
	--with-tools \
	--with-inputdrivers=lirc,keyboard,ps2mouse \
	--enable-static \
	--without-smooth-scaling
	
	make -j64
	make DESTDIR=${DEST_DIR_STATIC} install

	MAKE_RET=$?
	if [ $MAKE_RET -ne 0 ]; then
	   echo -e "\033[40;31mDirectFB Static Library Build Fail......($MAKE_RET)\033[0m"
	   exit $MAKE_RET
	else
	    echo -e "\033[40;32mDirectFB Static Library Build Success\033[0m"
	fi
fi

if [ -n "${STATIC_LIBRARY}" ]; then
  echo "tar dynamic and static library files to DirectFB-1.2.7-xx-install.tar.bz2..."
   
  #cd to build folder and tar
  cd ${DEST_DIR}
  ln -s libdirect-1.2.so.0.7.0 ./lib/libdirect-1.2.so.0
  ln -s libdirect-1.2.so.0.7.0 ./lib/libdirect.so
	
  ln -s libdirectfb-1.2.so.0.7.0 ./lib/libdirectfb-1.2.so.0
  ln -s libdirectfb-1.2.so.0.7.0 ./lib/libdirectfb.so
	
  ln -s libfusion-1.2.so.0.7.0 ./lib/libfusion-1.2.so.0
  ln -s libfusion-1.2.so.0.7.0 ./lib/libfusion.so
  cd -
	
  #find .a and .o
  cd ${DEST_DIR_STATIC}

  LOCAL_FILE=file.log
  rm ${LOCAL_FILE} -fr
  find ./* -name *.a > ${LOCAL_FILE}
  find ./* -name *.o >> ${LOCAL_FILE}
  cd -
 
  cp ${DEST_DIR_STATIC}/file.log .
    
  while read -r temp; do
	cp ${DEST_DIR_STATIC}/${temp} ${DEST_DIR}/${temp}		 
  done < ${LOCAL_FILE}

  cd ${DEST_DIR}
  tar jcf ../${INSTALL_TAR_NAME} ./
  cd -
  
  mv -f ${DEST_DIR}/../${INSTALL_TAR_NAME} ../../../library/DirectFB/

else
####	
    echo "tar dynamic library files to DirectFB-1.2.7-xx-install.tar.bz2..."
  
    #cd to build folder and tar
    cd ../../../build/DirectFB/DirectFB-1.2.7/
    ln -s libdirect-1.2.so.0.7.0 ./lib/libdirect-1.2.so.0
	ln -s libdirect-1.2.so.0.7.0 ./lib/libdirect.so
	
	ln -s libdirectfb-1.2.so.0.7.0 ./lib/libdirectfb-1.2.so.0
	ln -s libdirectfb-1.2.so.0.7.0 ./lib/libdirectfb.so
	
	ln -s libfusion-1.2.so.0.7.0 ./lib/libfusion-1.2.so.0
	ln -s libfusion-1.2.so.0.7.0 ./lib/libfusion.so
	
    tar jcf ../${INSTALL_TAR_NAME} ./
    cd -
    
    #copy to library folder
    mv -f ../../../build/DirectFB/${INSTALL_TAR_NAME} ../../../library/DirectFB/
   
####    
	exit 0
fi
else
   echo -e "\033[40;31mDirectFB is not supported!\033[0m"
   exit 0
fi
