/********************************************************************************************
 *     LEGAL DISCLAIMER 
 *
 *     (Header of MediaTek Software/Firmware Release or Documentation)
 *
 *     BY OPENING OR USING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES 
 *     THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE") RECEIVED 
 *     FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON AN "AS-IS" BASIS 
 *     ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES, EXPRESS OR IMPLIED, 
 *     INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR 
 *     A PARTICULAR PURPOSE OR NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY 
 *     WHATSOEVER WITH RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, 
 *     INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK 
 *     ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
 *     NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S SPECIFICATION 
 *     OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
 *     
 *     BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE LIABILITY WITH 
 *     RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, 
 *     TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE 
 *     FEES OR SERVICE CHARGE PAID BY BUYER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
 *     
 *     THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE WITH THE LAWS 
 *     OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF LAWS PRINCIPLES.  
 ************************************************************************************************/
/*
*
* \par Description
*   The definition of mt85 2d
*
*/

#ifndef __MT85_2D_H__
#define __MT85_2D_H__

#include <mtk/mt85.h>

#if (CONFIG_CHIP_VER_CURR >= CONFIG_CHIP_VER_MT8560)
#if (CONFIG_CHIP_VER_CURR <= CONFIG_CHIP_VER_MT8580)
#define MT85_SUPPORTED_DRAWINGFLAGS      (DSDRAW_BLEND              | \
                                          DSDRAW_SRC_PREMULTIPLY    | \
                                          DSDRAW_DST_PREMULTIPLY    | \
                                          DSDRAW_DEMULTIPLY)
#else
#define MT85_SUPPORTED_DRAWINGFLAGS      (DSDRAW_BLEND              | \
                                          DSDRAW_SRC_PREMULTIPLY    | \
                                          DSDRAW_DST_PREMULTIPLY    | \
                                          DSDRAW_DEMULTIPLY         | \
                                          DSDRAW_XOR)
#endif

// DFXL_DRAWLINE will be supported
#define MT85_SUPPORTED_DRAWINGFUNCTIONS  (DFXL_FILLRECTANGLE | \
                                          DFXL_FILLTRIANGLE  | \
                                          DFXL_DRAWRECTANGLE)

#if (CONFIG_CHIP_VER_CURR <= CONFIG_CHIP_VER_MT8550)
#define MT85_SUPPORTED_BLITTINGFLAGS     (DSBLIT_BLEND_ALPHACHANNEL | \
                                          DSBLIT_BLEND_COLORALPHA   | \
                                          DSBLIT_ROTATE180          | \
                                          DSBLIT_SRC_COLORKEY       | \
                                          DSBLIT_DST_COLORKEY)
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8555)
#define MT85_SUPPORTED_BLITTINGFLAGS     (DSBLIT_BLEND_ALPHACHANNEL | \
                                          DSBLIT_BLEND_COLORALPHA   | \
                                          DSBLIT_ROTATE180          | \
                                          DSBLIT_SRC_PREMULTIPLY    | \
                                          DSBLIT_DST_PREMULTIPLY    | \
                                          DSBLIT_DEMULTIPLY         | \
                                          DSBLIT_SRC_COLORKEY       | \
                                          DSBLIT_DST_COLORKEY)
#elif (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
#define MT85_SUPPORTED_BLITTINGFLAGS     (DSBLIT_BLEND_ALPHACHANNEL | \
                                          DSBLIT_BLEND_COLORALPHA   | \
                                          DSBLIT_ROTATE180          | \
                                          DSBLIT_SRC_PREMULTIPLY    | \
                                          DSBLIT_DST_PREMULTIPLY    | \
                                          DSBLIT_DEMULTIPLY         | \
                                          DSBLIT_SRC_COLORKEY       | \
                                          DSBLIT_DST_COLORKEY       | \
                                          DSBLIT_SRC_PREMULTCOLOR)
#elif (CONFIG_CHIP_VER_CURR >= CONFIG_CHIP_VER_MT8561)
#define MT85_SUPPORTED_BLITTINGFLAGS     (DSBLIT_BLEND_ALPHACHANNEL | \
                                          DSBLIT_BLEND_COLORALPHA   | \
                                          DSBLIT_ROTATE180          | \
                                          DSBLIT_SRC_PREMULTIPLY    | \
                                          DSBLIT_DST_PREMULTIPLY    | \
                                          DSBLIT_DEMULTIPLY         | \
                                          DSBLIT_SRC_COLORKEY       | \
                                          DSBLIT_DST_COLORKEY       | \
                                          DSBLIT_COLORIZE           | \
                                          DSBLIT_SRC_PREMULTCOLOR   | \
                                          DSBLIT_XOR)
#endif

#define MT85_SUPPORTED_BLITTINGFUNCTIONS (DFXL_BLIT | \
                                          DFXL_STRETCHBLIT)

#else

#if DFB_SUPPORT_GFX_ADAPTER
#define MT85_SUPPORTED_DRAWINGFLAGS      (DSDRAW_BLEND | \
                                          DSDRAW_SRC_PREMULTIPLY | \
                                          DSDRAW_DST_PREMULTIPLY | \
                                          DSDRAW_DEMULTIPLY)
#else
#define MT85_SUPPORTED_DRAWINGFLAGS      (DSDRAW_SRC_PREMULTIPLY | \
                                          DSDRAW_DEMULTIPLY)
#endif

// DFXL_DRAWLINE will be supported
#define MT85_SUPPORTED_DRAWINGFUNCTIONS  (DFXL_FILLRECTANGLE | \
                                          DFXL_FILLTRIANGLE  | \
                                          DFXL_DRAWRECTANGLE)

#if DFB_SUPPORT_GFX_ADAPTER
#define MT85_SUPPORTED_BLITTINGFLAGS     (DSBLIT_BLEND_ALPHACHANNEL | \
                                          DSBLIT_BLEND_COLORALPHA   | \
                                          DSBLIT_SRC_PREMULTIPLY    | \
                                          DSBLIT_DST_PREMULTIPLY    | \
                                          DSBLIT_DEMULTIPLY         | \
                                          DSBLIT_ROTATE180          | \
                                          DSBLIT_SRC_COLORKEY       | \
                                          DSBLIT_DST_COLORKEY)
#else
#define MT85_SUPPORTED_BLITTINGFLAGS     (DSBLIT_BLEND_ALPHACHANNEL | \
                                          DSBLIT_BLEND_COLORALPHA   | \
                                          DSBLIT_SRC_COLORKEY)
#endif

#define MT85_SUPPORTED_BLITTINGFUNCTIONS (DFXL_BLIT | \
                                          DFXL_STRETCHBLIT)

#endif

// -- gfx debug
#define DFB_DEBUG_INFO              (((mt8530fb_dfb_debug_info*)mt85_debuginfo())->gfx)

#define DFB_GFX_SW_SOLUTION         (DFB_DEBUG_INFO.set_gfx_sw)
#define DFB_GFX_MOD_FLAGS           (DFB_DEBUG_INFO.mod_flag_func)
#define DFB_GFX_LOG(fmt...)         do {if (DFB_DEBUG_INFO.log_enable) {printf(fmt);}} while (0)
// -

DFBResult mt85EngineSync   ( void                *drv,
                             void                *dev );

void mt85FlushTextureCache( void *driver_data, void *device_data );

void mt85FlushReadCache( void *driver_data, void *device_data );

void      mt85EngineReset  ( void                *drv,
                             void                *dev );

void      mt85EmitCommands ( void                *drv,
                             void                *dev );

void      mt85CheckState   ( void                *drv,
                             void                *dev,
                             CardState           *state,
                             DFBAccelerationMask  accel );

void      mt85SetState     ( void                *drv,
                             void                *dev,
                             GraphicsDeviceFuncs *funcs,
                             CardState           *state,
                             DFBAccelerationMask  accel );

#endif

