#ifndef __MT85_GFX_H__
#define __MT85_GFX_H__

//**********************include files******************************************//
#include "x_typedef.h"
#include "x_memtype.h"
#include "u_common.h"

#if CONFIG_SYS_MEM_PHASE3
#include "x_kmem.h"
#endif


//**********************define macro******************************************//
#define DFB_SUPPORT_GFX_ADAPTER 1 //dfb

//#if ((CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8520) || (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8550) || (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560) || (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8580))
#if ((CONFIG_CHIP_VER_CURR >= CONFIG_CHIP_VER_MT8520) && (CONFIG_CHIP_VER_CURR != CONFIG_CHIP_VER_MT8555))
#define GFX_HAL_HW_INST_NUM     1
#else
#define GFX_HAL_HW_INST_NUM     2
#endif
#define GFX_DRV_EMU_HAL     GFX_HAL_HW_INST_NUM
#define GFX_DRV_INST_NUM    GFX_HAL_HW_INST_NUM

#if (CONFIG_DRV_ONLY)
#else
#define SUPPORT_FRAME_ACCURATE
#endif


//**********************enumerations******************************************//
typedef enum _GFX_COLORMODE_T
{
    GFX_COLORMODE_AYCbCr_CLUT2  = 0,
    GFX_COLORMODE_AYCbCr_CLUT4  = 1,
    GFX_COLORMODE_AYCbCr_CLUT8  = 2,
    GFX_COLORMODE_CbYCrY_16     = 3,
    GFX_COLORMODE_YCbYCr_16     = 4,
    GFX_COLORMODE_AYCbCr_D8888  = 5,
    GFX_COLORMODE_ARGB_CLUT2    = 6,
    GFX_COLORMODE_ARGB_CLUT4    = 7,
    GFX_COLORMODE_ARGB_CLUT8    = 8,
    GFX_COLORMODE_RGB_D565      = 9,
    GFX_COLORMODE_ARGB_D1555    = 10,
    GFX_COLORMODE_ARGB_D4444    = 11,
    GFX_COLORMODE_ARGB_D8888    = 12,
    GFX_COLORMDOE_YUV_420_BLK   = 13,
    GFX_COLORMODE_YUV_420_RS    = 14,
    GFX_COLORMDOE_YUV_422_BLK   = 15,
    GFX_COLORMODE_YUV_422_RS    = 16,
    GFX_COLORMDOE_YUV_444_BLK   = 17,
    GFX_COLORMODE_YUV_444_RS    = 18
} GFX_COLORMODE_T;

typedef enum
{
    GFX_CLEAR = 0,
    GFX_DST_IN,
    GFX_DST_OUT,
    GFX_DST_OVER,
    GFX_SRC,
    GFX_SRC_IN,
    GFX_SRC_OUT,
    GFX_SRC_OVER,
    GFX_DST,
    GFX_SRC_ATOP,
    GFX_DST_ATOP,
    GFX_XOR,
#if (CONFIG_CHIP_VER_CURR > CONFIG_CHIP_VER_MT8560)
    GFX_NONE,
    GFX_ADD,
#endif
    GFX_RULE_MAX
} GFX_PD_RULE_T;

typedef enum
{
    GFX_CLOCKWISE   = 0,
    GFX_C_CLOCKWISE,
    GFX_ROTATE_NULL
} GFX_ROTATE_FLAG_T;

typedef struct
{
    UINT32 ui4_unused;
} *GFX_HRGNLIST_T;

//gfx
typedef struct
{
    UINT32 ui4_unused;
} *GFX_HPALETTE_T;

typedef enum
{
    GFX_PALETTE_MSB = 0,
    GFX_PALETTE_LSB = 1,
} GFX_BYTE_ALIGNED_T;

typedef enum
{
    GFX_ROP_NOT_SRC = 0,
    GFX_ROP_NOT_DST,
    GFX_ROP_SRC_XOR_DST,
    GFX_ROP_SRC_XNOR_DST,
    GFX_ROP_SRC_AND_DST,
    GFX_ROP_NOT_SRC_AND_DST,
    GFX_ROP_SRC_AND_NOT_DST,
    GFX_ROP_NOT_SRC_AND_NOT_DST,
    GFX_ROP_SRC_OR_DST,
    GFX_ROP_NOT_SRC_OR_DST,
    GFX_ROP_SRC_OR_NOT_DST,
    GFX_ROP_NOT_SRC_OR_NOT_DST
} GFX_ROP_TYPE_T;

//add for 8530 emulation for mirror and flip msz00441 080604
typedef enum 
{
    E_BITBLT_SRC_MIRROR = 0,
    E_BITBLT_SRC_FLIP,
    E_BITBLT_DST_MIRROR,
    E_BITBLT_DST_FLIP,
    E_BITBLT_SRC_FLIPMIRROR,
    E_BITBLT_DST_FLIPMIRROR,
    E_BITBLT_NORMAL,
    E_BITBLT_MF_MAX
}EGFX_BITBLT_OPT_T;

typedef enum _GFX_OPTION_T
{
    GFX_OPTION_COMP     = 0,
    GFX_OPTION_XOR     = 1,
} GFX_OPTION_T;

typedef enum _GFX_YCBCR_FORMAT_T
{
    GFX_YCBCR_420_MB  = 0,
    GFX_YCBCR_420_LNR = 1,
    GFX_YCBCR_422_LNR = 2       /* MT538x only */
} GFX_YCBCR_FORMAT_T;

typedef enum _GFX_BUFF_CMD_TYPE_T
{
    GFX_BUFF_TYPE_GROUP_1 = 0,
    GFX_BUFF_TYPE_FILL_RECT,
    GFX_BUFF_TYPE_BITBLT,
    GFX_BUFF_TYPE_ALPHA_COMPOSITION,
    GFX_BUFF_TYPE_STRETCH_BITBLT,
    GFX_BUFF_TYPE_DRAW_LINE_H,
    GFX_BUFF_TYPE_DRAW_LINE_V,
    GFX_BUFF_TYPE_TRANSPARENT_BITBLT,
    GFX_BUFF_TYPE_TRANSPARENT_FILL,
    GFX_BUFF_TYPE_REPLACE_COLOR,
    GFX_BUFF_TYPE_ALPHA_BLENDING, //10
    GFX_BUFF_TYPE_EXT_ALPHA_MUL,
    GFX_BUFF_TYPE_ALPHA_BITBLT,  
    GFX_BUFF_TYPE_ALPHAMAP_BITBLT,
    GFX_BUFF_TYPE_COLOR_BITBLT,
    GFX_BUFF_TYPE_ADV_STRETCH_BITBLT,
    GFX_BUFF_TYPE_ROP_BITBLT,
    GFX_BUFF_TYPE_PALETTE_BITBLT,       
    GFX_BUFF_TYPE_ROTATE_90 ,
    GFX_BUFF_TYPE_IGPG_DECODE,

    GFX_BUFF_TYPE_FILL_COMPOSITION, // 20
    GFX_BUFF_TYPE_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_ADV_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_ROTATE_STRETCH ,
    GFX_BUFF_TYPE_ROTATE_ADV_STRETCH,
    GFX_BUFF_TYPE_ROTATE_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_ROTATE_ADV_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_ROTATE_COMPOSITION,
    GFX_BUFF_TYPE_MIRROR_FLIP,
    GFX_BUFF_TYPE_ROTATE_ONLY,
    GFX_BUFF_TYPE_CLUT8_STRETCH_COMPOSITION, //30
    GFX_BUFF_TYPE_CLUT8_ADV_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_CLUT8_ROTATE_STRETCH ,
    GFX_BUFF_TYPE_CLUT8_ROTATE_ADV_STRETCH,
    GFX_BUFF_TYPE_CLUT8_ROTATE_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_CLUT8_ROTATE_ADV_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_CLUT8_ROTATE_COMPOSITION,
    GFX_BUFF_TYPE_CLUT8_ROTATE,
    GFX_BUFF_TYPE_FLIPGRADEFILL, //38
    GFX_BUFF_TYPE_LOSSLESS_ENC,
    GFX_BUFF_TYPE_LOSSLESS_MULTI_ENC,
    GFX_BUFF_TYPE_LOSSLESS_TO_WT,//41
    GFX_BUFF_TYPE_LOSSLESS_BITBLT,
    GFX_BUFF_TYPE_LOSSLESS_FULLSIZE_DECODE,
    GFX_BUFF_TYPE_LOSSLESS_TRANSPARENTBITBLT,
    GFX_BUFF_TYPE_LOSSLESS_ALPHABLENDING,
    GFX_BUFF_TYPE_LOSSLESS_ALPHACOMPOSE,
    GFX_BUFF_TYPE_LOSSLESS_STRETCHBITBLT,
    GFX_BUFF_TYPE_LOSSLESS_STRETCHCOMPOSE,
    GFX_BUFF_TYPE_LOSSLESS_FILLCOMPOSE,
    GFX_BUFF_TYPE_LOSSLESS_ROTATE_STRETCH,

    // used for DirectFB
    GFX_BUFF_TYPE_BITBLT_DFB,
    GFX_BUFF_TYPE_ALPHA_COMPOSE_DFB,
    GFX_BUFF_TYPE_STRETCHBLIT_DFB,
    GFX_BUFF_TYPE_STRETCHCOMPOSE_DFB,
    GFX_BUFF_TYPE_FILL_RECT_COMPOSE_DFB, 
    GFX_BUFF_TYPE_A8_COMPOSE_DFB,
    GFX_BUFF_TYPE_FILL_RECT_COMPOSE,
    GFX_BUFF_TYPE_DRAW_RECT,
    GFX_BUFF_TYPE_DRAW_RECT_COMPOSE,
    GFX_BUFF_TYPE_DRAW_OBLIQUELINE,
    GFX_BUFF_TYPE_DRAW_OBLIQUELINE_COMPOSE,
    GFX_BUFF_TYPE_FILL_TRIANGLE,
    GFX_BUFF_TYPE_FILL_TRIANGLE_COMPOSE,
    GFX_BUFF_TYPE_COLORKEYBITBLT,
    GFX_BUFF_TYPE_COLORKEY_STRETCH_BITBLT,
    GFX_BUFF_TYPE_FILL_RECT_BLEND,
    GFX_BUFF_TYPE_STRETCH_BITBLT_BLEND,  
    // used for DirectFB Pre-multiply
    GFX_BUFF_TYPE_PM_FILL_RECT,
    GFX_BUFF_TYPE_PM_FILL_RECT_BLEND,
    GFX_BUFF_TYPE_PM_BITBLT,
    GFX_BUFF_TYPE_PM_ALPHA_COMPOSITION,
    GFX_BUFF_TYPE_PM_STRETCH_BITBLT,
    GFX_BUFF_TYPE_PM_STRETCH_BITBLT_BLEND,

    GFX_BUFF_TYPE_COLORIZE_BITBLT,
    GFX_BUFF_TYPE_FLIP,
    GFX_BUFF_TYPE_3D_FLIP,
    GFX_BUFF_TYPE_3DHORROTATE,
    GFX_BUFF_TYPE_I2D_COMPOSE,
    GFX_BUFF_TYPE_ALPHA_COMPOSITION_PRECOLORIZE,
    
    // Group 2
    GFX_BUFF_TYPE_GROUP_2 = 200,
    GFX_BUFF_TYPE_LOSSLESS_COMPRESS_BITBLT,
    GFX_BUFF_TYPE_3D_LOSSLESS_COMPRESS_BITBLT,
//    GFX_BUFF_TYPE_LOSSLESS_FLIP,

    // Group 3
    GFX_BUFF_TYPE_GROUP_3 = 300,
    GFX_BUFF_TYPE_YCBCR_TO_RGB,
    GFX_BUFF_TYPE_AYCBCR_TO_ARGB,
    GFX_BUFF_TYPE_Y2R_BITBLT,
    GFX_BUFF_TYPE_Y2R_COMPOSE,
    GFX_BUFF_TYPE_Y2R_XOR,
    GFX_BUFF_TYPE_Y2R_STRETCH,
    GFX_BUFF_TYPE_YUV_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_YUV_ADV_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_YUV_ROTATE_STRETCH ,
    GFX_BUFF_TYPE_YUV_ROTATE_ADV_STRETCH,
    GFX_BUFF_TYPE_YUV_ROTATE_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_YUV_ROTATE_ADV_STRETCH_COMPOSITION,
    GFX_BUFF_TYPE_YUV_ROTATE_COMPOSITION,
    GFX_BUFF_TYPE_YUV_ROTATE,
    GFX_BUFF_TYPE_YUV_TO_RGB_BITBLT,

    // Group 4
    GFX_BUFF_TYPE_GROUP_4 = 400,
    GFX_BUFF_TYPE_FLUSH,
    GFX_BUFF_TYPE_STOP,
    
    GFX_BUFF_TYPE_SYNC_TO_DRAM,
    GFX_BUFF_TYPE_SYNC_TABLE,

    GFX_BUFF_TYPE_MAX
} GFX_BUFF_CMD_TYPE_T;

//GFX Priority
#if (GFX_DRV_INST_NUM == 1)
typedef enum
{
    GFX_DRV_CMDBUF_PRIORITY_LOW = 12,       ///< Low priority, for normal image decoder driver
    GFX_DRV_CMDBUF_PRIORITY_MID = 13,       ///< Medium priority, for video decoder driver SD source using
    GFX_DRV_CMDBUF_PRIORITY_HIGH = 14,     ///< High priority, for video decoder driver HD source using
    GFX_DRV_CMDBUF_PRIORITY_HIGHEST = 15,     ///< Highest priority, for video decoder driver HD source using
    GFX_DRV_CMDBUF_PRIORITY_MAX            ///< The max
} GFX_DRV_CMDBUF_PRIORITY;
#else
typedef enum
{
    GFX_DRV_CMDBUF_PRIORITY_LOW = 1,       ///< Low priority, for normal image decoder driver
    GFX_DRV_CMDBUF_PRIORITY_MID = 3,       ///< Medium priority, for video decoder driver SD source using
    GFX_DRV_CMDBUF_PRIORITY_HIGH = 10,     ///< High priority, for video decoder driver HD source using
    GFX_DRV_CMDBUF_PRIORITY_HIGHEST = 15,     ///< Highest priority, for video decoder driver HD source using
    GFX_DRV_CMDBUF_PRIORITY_MAX            ///< The max
} GFX_DRV_CMDBUF_PRIORITY;
#endif

/// GFX  Flush Type
typedef enum
{
   GFX_DRV_FLUSH_NONE = 0,      ///< Not available.
   GFX_DRV_FORCE_FLUSH,         ///< force flush
    GFX_DRV_AUTO_FLUSH        ///< auto flush
}GFX_DRV_FLUSH_TYPE;

/// GFX Cmd Buf State Machine
typedef enum
{
   GFX_CMDBUF_STATE_IDLE,               ///< Cmd buffer init state
   GFX_CMDBUF_STATE_ACTIVE,             ///< Cmd buffer active
   GFX_CMDBUF_STATE_WAITFLUSH,          ///< Cmd buffer wait flush
   GFX_CMDBUF_STATE_INFLUSH,            ///< Cmd buffer in flush
   GFX_CMDBUF_STATE_MAX                 ///< The max
} GFX_CMDBUF_STATE;

//rle 
typedef enum _RLE_COLORMODE_T
{
    RLE_COLORMODE_AYCbCr_CLUT2  = 0,
    RLE_COLORMODE_AYCbCr_CLUT4  = 1,
    RLE_COLORMODE_AYCbCr_CLUT8  = 2,
    RLE_COLORMODE_CbYCrY_16     = 3,
    RLE_COLORMODE_YCbYCr_16     = 4,
    RLE_COLORMODE_AYCbCr_D8888  = 5,
    RLE_COLORMODE_ARGB_CLUT2    = 6,
    RLE_COLORMODE_ARGB_CLUT4    = 7,
    RLE_COLORMODE_ARGB_CLUT8    = 8,
    RLE_COLORMODE_RGB_D565      = 9,
    RLE_COLORMODE_ARGB_D1555    = 10,
    RLE_COLORMODE_ARGB_D4444    = 11,
    RLE_COLORMODE_ARGB_D8888    = 12,
    RLE_COLORMDOE_YUV_420_BLK   = 13,
    RLE_COLORMODE_YUV_420_RS    = 14,
    RLE_COLORMDOE_YUV_422_BLK   = 15,
    RLE_COLORMODE_YUV_422_RS    = 16,
    RLE_COLORMDOE_YUV_444_BLK   = 17,
    RLE_COLORMODE_YUV_444_RS    = 18
}RLE_COLORMODE_T;



//**********************structions*****************************************//
//rle
typedef struct _RLE_IMG_DIRECT_DECODE_T
{	  
    INT32           u4TicketId;   
    BOOL            bSyncEn;       
    VOID        __cross_space__    *pv_img_buf;        /* image data */
    VOID        __cross_space__    *pv_img_buf2;       /* image data2 */
    UINT32          ui4_img_size;       /* image size */
    VOID        __cross_space__    *pv_type_data;      /* type data */
		
    VOID        __cross_space__    *pv_dst;            /* destination starting address */

    UINT32          ui4_src_x;          /* x offset in the source image in pixels */
    UINT32          ui4_src_y;          /* y offset in the source image in pixels */
    UINT32          ui4_src_width;      /* width to be decoded in pixels */
    UINT32          ui4_src_height;     /* height to be decoded in pixels */

    UINT32          ui4_dst_x;          /* x offset in the destination in pixels */
    UINT32          ui4_dst_y;          /* y offset in the destination in pixels */
    UINT32          ui4_dst_width;      /* expected output width in pixels */
    UINT32          ui4_dst_height;     /* expected output height in pixels */
    UINT32          ui4_dst_pitch;      /* pitch of the destination image */
    UINT32          ui4_dst2_pitch;     /* pitch of the additional destination image */
    RLE_COLORMODE_T e_dst_cm;           /* destination color mode */    
    UINT32          ui4ModuleID;
#ifdef SUPPORT_FRAME_ACCURATE
    UINT64          ui8Tickets;
#endif
} RLE_IMG_DIRECT_DECODE_T;

typedef struct _GFX_FILL_T
{
   #if 1 //def USE_RESOURCE_MANAGER 
    INT32           u4TicketId;
    UINT32            u4Flag;   
   #endif
    VOID*     __cross_space__ pv_dst;
    VOID*     __cross_space__ pv_dst2;
    INT32           i4_dst_x;
    INT32           i4_dst_y;
    UINT32          ui4_dst_pitch;
    UINT32          ui4_dst_pitch2;
    GFX_COLORMODE_T e_dst_cm;
    BOOL           b_compressed;       

    UINT32          ui4_width;
    UINT32          ui4_height;
    UINT32          ui4_color;
    UINT32          ui4ModuleID;
} GFX_FILL_T;

typedef struct _GFX_DRAW_OBLIQUELINE_T
{
   #if 1 //def USE_RESOURCE_MANAGER 
    INT32           u4TicketId;
    UINT32            u4Flag;   
   #endif
    VOID*     __cross_space__ pv_dst;
    VOID*     __cross_space__ pv_dst2;
    INT32           i4_x_start;
    INT32           i4_y_start;
    INT32           i4_x_end;
    INT32           i4_y_end;
    UINT32          ui4_dst_pitch;
    UINT32          ui4_dst_pitch2;
    GFX_COLORMODE_T e_dst_cm;
    BOOL           b_compressed;       

    UINT32          ui4_color;
    UINT32          ui4ModuleID;
} GFX_DRAW_OBLIQUELINE_T;


typedef struct _GFX_DRAW_OBLIQUELINE_COMPOSE_T
{
   #if 1 //def USE_RESOURCE_MANAGER 
    INT32           u4TicketId;
    UINT32            u4Flag;   
   #endif
    VOID*     __cross_space__ pv_dst;
    VOID*     __cross_space__ pv_dst2;
    INT32           i4_x_start;
    INT32           i4_y_start;
    INT32           i4_x_end;
    INT32           i4_y_end;
    UINT32          ui4_dst_pitch;
    UINT32          ui4_dst_pitch2;
    GFX_COLORMODE_T e_dst_cm;
    BOOL           b_compressed;

    UINT8           ui1_alpha;
    GFX_PD_RULE_T   e_rule;
    UINT32          ui4_color;
    UINT32          ui4ModuleID;
} GFX_DRAW_OBLIQUELINE_COMPOSE_T;

typedef struct _GFX_FILLTRIANGLE_T
{
   #if 1 //def USE_RESOURCE_MANAGER 
    INT32           u4TicketId;
    UINT32            u4Flag;   
   #endif
    VOID*     __cross_space__ pv_dst;
    VOID*     __cross_space__ pv_dst2;
    INT32           i4_dst_x1;
    INT32           i4_dst_y1;
    INT32           i4_dst_x2;
    INT32           i4_dst_y2;
    INT32           i4_dst_x3;
    INT32           i4_dst_y3;
    UINT32          ui4_dst_pitch;
    UINT32          ui4_dst_pitch2;
    GFX_COLORMODE_T e_dst_cm;
    BOOL            b_compressed;       

    UINT32          ui4_color;
    UINT32          ui4ModuleID;
} GFX_FILLTRIANGLE_T;

typedef struct _GFX_FILLTRIANGLE_COMPOSE_T
{
   #if 1 //def USE_RESOURCE_MANAGER 
    INT32           u4TicketId;
    UINT32            u4Flag;   
   #endif
    VOID*     __cross_space__ pv_dst;
    VOID*     __cross_space__ pv_dst2;
    INT32           i4_dst_x1;
    INT32           i4_dst_y1;
    INT32           i4_dst_x2;
    INT32           i4_dst_y2;
    INT32           i4_dst_x3;
    INT32           i4_dst_y3;
    UINT32          ui4_dst_pitch;
    UINT32          ui4_dst_pitch2;
    GFX_COLORMODE_T e_dst_cm;
    BOOL            b_compressed;       

    UINT32          ui4_color;
    UINT32          ui4ModuleID;

    UINT8           ui1_alpha;
    GFX_PD_RULE_T   e_rule;
} GFX_FILLTRIANGLE_COMPOSE_T;

typedef struct _GFX_FILL_BLEND_T
{
   #if 1 //def USE_RESOURCE_MANAGER 
    INT32           u4TicketId;
    UINT32          u4Flag;   
   #endif
    VOID*     __cross_space__ pv_dst;
    VOID*     __cross_space__ pv_dst2;
    INT32           i4_dst_x;
    INT32           i4_dst_y;
    UINT32          ui4_dst_pitch;
    UINT32          ui4_dst_pitch2;
    GFX_COLORMODE_T e_dst_cm;
    BOOL            b_compressed;       

    UINT32          ui4_width;
    UINT32          ui4_height;
    UINT32          ui4_color;
    UINT32          ui4ModuleID;

    UINT8           ui1_alpha;
} GFX_FILL_BLEND_T;

typedef struct _GFX_FILL_COMPOSE_T
{
   #if 1 //def USE_RESOURCE_MANAGER 
    INT32           u4TicketId;
    UINT32          u4Flag;   
   #endif
    VOID*     __cross_space__ pv_dst;
    VOID*     __cross_space__ pv_dst2;
    INT32           i4_dst_x;
    INT32           i4_dst_y;
    UINT32          ui4_dst_pitch;
    UINT32          ui4_dst_pitch2;
    GFX_COLORMODE_T e_dst_cm;
    BOOL            b_compressed;       

    UINT32          ui4_width;
    UINT32          ui4_height;
    UINT32          ui4_color;
    UINT32          ui4ModuleID;

    UINT8           ui1_alpha;
    GFX_PD_RULE_T   e_rule;
    UINT32          ui4_src_pm_rd;
    UINT32          ui4_dst_pm_rd;
    UINT32          ui4_dst_pm_wr;
} GFX_FILL_COMPOSE_T;

 #if 1//def USE_RESOURCE_MANAGER   

 #define COMMON_BITBLT_FIELDS        \
    INT32           u4TicketId;     \
    UINT32         u4Flag;       \
    VOID*       __cross_space__   pv_src;         \
    INT32           i4_src_x;       \
    INT32           i4_src_y;       \
    UINT32          ui4_src_pitch;  \
    GFX_COLORMODE_T e_src_cm;       \
    BOOL           b_src_compressed;       \
                                    \
    VOID*       __cross_space__    pv_dst;         \
    INT32           i4_dst_x;       \
    INT32           i4_dst_y;       \
    UINT32          ui4_dst_pitch;  \
    GFX_COLORMODE_T e_dst_cm;       \
    BOOL           b_dst_compressed;       \
                                    \
    UINT32          ui4_width;      \
    UINT32          ui4_height;     \
    GFX_YCBCR_FORMAT_T  e_ycbcr_format;     \
    VOID*           __cross_space__  pv_cbcr_or_palette;             \
    UINT32              ui4_cbcr_pitch;     \
    UINT8              ui1_ycbcr_alpha;  \
    GFX_BYTE_ALIGNED_T  e_byte_aligned;  \
    GFX_HPALETTE_T      h_palette;       \
    UINT32          ui4ModuleID;         \
    UINT32          u4_alCom_normal;       \
    UINT32          u4_src_picth_en;   
#else

#define COMMON_BITBLT_FIELDS        \
    BOOL            bSyncEn;       \
    VOID*       __cross_space__   pv_src;         \
    INT32           i4_src_x;       \
    INT32           i4_src_y;       \
    UINT32          ui4_src_pitch;  \
    GFX_COLORMODE_T e_src_cm;       \
    BOOL           b_src_compressed;       \
                                    \
    VOID*       __cross_space__    pv_dst;         \
    INT32           i4_dst_x;       \
    INT32           i4_dst_y;       \
    UINT32          ui4_dst_pitch;  \
    GFX_COLORMODE_T e_dst_cm;       \
    BOOL           b_dst_compressed;       \
                                    \
    UINT32          ui4_width;      \
    UINT32          ui4_height;

#endif  

typedef struct _GFX_BITBLT_BASE_T
{
    COMMON_BITBLT_FIELDS
} GFX_BITBLT_BASE_T;

typedef struct _GFX_BITBLT_T
{
    COMMON_BITBLT_FIELDS

    UINT8       ui1_alpha;
    UINT32      u4Colorize;
    UINT32      ui4_color;
    
    UINT32      u4RollBackEn;
    UINT32      u4QulityMode; 
    UINT32      u4LineSeparate;
} GFX_BITBLT_T;

typedef struct _GFX_PREMULT_BITBLT_T
{
    COMMON_BITBLT_FIELDS

    UINT8      ui1_alpha;

    UINT32     ui4_src_premult;
    UINT32     ui4_dst_premult;
    UINT32     ui4_dst_premult_wr;

    UINT32     u4RollBackEn;
    UINT32     u4QulityMode; 
    UINT32     u4LineSeparate;
} GFX_PREMULT_BITBLT_T;

typedef struct _GFX_PREMULT_STRETCH_BITBLT_T
{
    COMMON_BITBLT_FIELDS

    UINT32          ui4_dst_width;
    UINT32          ui4_dst_height;
    //UINT32*        pv_palette;

    UINT32          ui4_src_premult;
    UINT32          ui4_dst_premult;
    UINT32          ui4_dst_premult_wr;
    UINT8           ui1_alpha;
    GFX_PD_RULE_T   e_rule;
} GFX_PREMULT_STRETCH_BITBLT_T;

typedef struct _GFX_PREMULT_STRETCH_BITBLT_BLEND_T
{
    COMMON_BITBLT_FIELDS

    UINT32      ui4_dst_width;
    UINT32      ui4_dst_height;

    UINT32      ui4_src_premult;
    UINT32      ui4_dst_premult;
    UINT32      ui4_dst_premult_wr;
    UINT8       ui1_alpha;
    GFX_PD_RULE_T   e_rule;
} GFX_PREMULT_STRETCH_BITBLT_BLEND_T;

typedef struct _GFX_PREMULT_ALPHA_COMPOSITION_T
{
    COMMON_BITBLT_FIELDS

    UINT8           ui1_alpha;

    GFX_PD_RULE_T   e_rule;

    BOOL            b_rect_src_option;
    UINT32          ui4_color;

    UINT32          ui4_src_premult;
    UINT32          ui4_dst_premult;
    UINT32          ui4_dst_premult_wr;
    UINT32          u4SrcPremultColor;
} GFX_PREMULT_ALPHA_COMPOSITION_T;

typedef struct _GFX_BITBLT_MIRROR_FLIP_T
{
    COMMON_BITBLT_FIELDS

    UINT8       ui1_alpha;
    EGFX_BITBLT_OPT_T u4Opt;
    
} GFX_BITBLT_MIRROR_FLIP_T;

typedef GFX_BITBLT_T GFX_ALPHA_MUL_T;

typedef GFX_BITBLT_BASE_T GFX_ALPHAMAP_BITBLT_T;

typedef struct _GFX_STRETCH_BITBLT_T
{
    COMMON_BITBLT_FIELDS

    UINT32      ui4_dst_width;
    UINT32      ui4_dst_height;
   // colorkey
    UINT32      b_key_sd_sel;
    UINT32      ui4_color_space_min;
    UINT32      ui4_color_space_max;
    //UINT32*    pv_palette;
} GFX_STRETCH_BITBLT_T;

typedef struct _GFX_COLORKEY_BITBLT_T
{
    COMMON_BITBLT_FIELDS

    UINT32      b_key_sd_sel;
    UINT32      ui4_color_space_min;
    UINT32      ui4_color_space_max;
} GFX_COLORKEY_BITBLT_T;

typedef struct _GFX_COLORKEY_STRETCH_BITBLT_T
{
    COMMON_BITBLT_FIELDS

    UINT32      ui4_dst_width;
    UINT32      ui4_dst_height;

    UINT32      b_key_sd_sel;
    UINT32      ui4_color_space_min;
    UINT32      ui4_color_space_max;
} GFX_COLORKEY_STRETCH_BITBLT_T;

typedef struct _GFX_TRANSPARENT_BITBLT_T
{
    COMMON_BITBLT_FIELDS

#if 0
    UINT8       ui1_alpha;
#endif

    BOOL        b_inverse_masking;
    UINT32      ui4_color_space_min;
    UINT32      ui4_color_space_max;
} GFX_TRANSPARENT_BITBLT_T;

typedef struct _GFX_TRANSPARENT_FILL_T
{
    COMMON_BITBLT_FIELDS

#if 0
    UINT8       ui1_alpha;
#endif

    BOOL        b_inverse_masking;
    UINT32      ui4_color_space_min;
    UINT32      ui4_color_space_max;

    UINT32      ui4_fill_color;
} GFX_TRANSPARENT_FILL_T;

typedef GFX_BITBLT_T GFX_ALPHA_BLEND_T;

typedef struct _GFX_ALPHA_COMPOSITION_T
{
    COMMON_BITBLT_FIELDS

    UINT8           ui1_alpha;
    GFX_PD_RULE_T   e_rule;
    BOOL            b_rect_src_option;
    UINT32          ui4_color;
    UINT32          u4Colorize;
    UINT32          u4PremultSrcRd;
    UINT32          u4PremultDstRd;
    UINT32          u4PremultDstWr;
} GFX_ALPHA_COMPOSITION_T;

typedef struct _GFX_ROTATE_T
{
    COMMON_BITBLT_FIELDS

    GFX_ROTATE_FLAG_T e_direction;
} GFX_ROTATE_T;

typedef struct _GFX_YCBCR_TO_RGB
{
    COMMON_BITBLT_FIELDS

    VOID      *pv_cbcr;
    //UINT32              ui4_cbcr_pitch;
    UINT8               ui1_alpha;
    //GFX_YCBCR_FORMAT_T  e_ycbcr_format;
} GFX_YCBCR_TO_RGB_T;

typedef struct _GFX_PLTBLT_T
{
    COMMON_BITBLT_FIELDS

    //GFX_BYTE_ALIGNED_T  e_byte_aligned;
    //GFX_HPALETTE_T      h_palette;
    //UINT32*                  pv_palette;
} GFX_PLTBLT_T;

typedef struct _GFX_ROP_BITBLT_T
{
    COMMON_BITBLT_FIELDS

    GFX_ROP_TYPE_T      e_rop_type;
} GFX_ROP_BITBLT_T;


typedef struct _GFX_REPLACE_COLOR_T
{
    COMMON_BITBLT_FIELDS

    UINT8           ui1_alpha;

    UINT32    __local_space__ *pui4_original_color;
    UINT32    __local_space__ *pui4_new_color;
    UINT8           ui1_color_num;
} GFX_REPLACE_COLOR_T;

typedef struct _GFX_ROTATE_STRETCH_ALPHACOMP_T
{
    COMMON_BITBLT_FIELDS
    UINT8           ui1_alpha_assigned;
    UINT8           ui1_ac_ar;
    GFX_PD_RULE_T   e_rule;
    BOOL             b_rect_src_option;
    UINT32          ui4_color;
    UINT32          ui4_dst_width;
    UINT32          ui4_dst_height;
    GFX_OPTION_T  e_option;
    UINT32          ui4_rot_op;
} GFX_ROTATE_STRETCH_ALPHACOMP_T;  

typedef struct _GFX_REFLECT_T
{
    COMMON_BITBLT_FIELDS
    //UINT8       ui1_alpha;
    //EGFX_BITBLT_OPT_T u4Opt;
    INT32       i4StartAlpha;
    INT32       i4EndAlpha;
    //INT32       i4AlphaHeight;
    //UINT32      u4GradeFliiMode;
    //UINT32      ui4_color;
}GFX_REFLECT_T;

#define GFX_BLT_FLIP                 ((UINT32) 0x10000)
#define GFX_BLT_ROTATE_MASK          ((UINT32) 0xffff)
#define GFX_BLT_ROTATE_NONE          ((UINT32)      0)
#define GFX_BLT_ROTATE_CW90          ((UINT32)     90)
#define GFX_BLT_ROTATE_CW180         ((UINT32)    180)
#define GFX_BLT_ROTATE_CW270         ((UINT32)    270)
#define GFX_BLT_ROTATE_NONE_FLIP          ((UINT32) 0x10000)
#define GFX_BLT_ROTATE_CW90_FLIP            ((UINT32) 0x1005A)
#define GFX_BLT_ROTATE_CW180_FLIP           ((UINT32)0x100B4)
#define GFX_BLT_ROTATE_CW270_FLIP           ((UINT32)  0x1010E)


typedef struct _GFX_FLIP_T 
{
    UINT32            ui4_plane_id;
    GFX_HRGNLIST_T    rgnlist;
    UINT32            ui4_flip_id;
    BOOL              b_force;
} GFX_FLIP_T;

typedef struct _GFX_FLIP_3D_T 
{
    UINT32            ui4_plane_id;
    GFX_HRGNLIST_T    rgnlist_left;
    GFX_HRGNLIST_T    rgnlist_right;
    UINT32            ui4_flip_id;
    BOOL              b_force;
} GFX_FLIP_3D_T;

#if (CONFIG_CHIP_VER_CURR >= CONFIG_CHIP_VER_MT8560)
typedef struct _GFX_BITBLT_DFB_T
{
    INT32           u4TicketId;
    VOID*           pv_src;
    INT32           i4_src_x;
    INT32           i4_src_y;
    UINT32          ui4_src_pitch;
    GFX_COLORMODE_T e_src_cm;

    VOID*           pv_dst;
    INT32           i4_dst_x;
    INT32           i4_dst_y;
    UINT32          ui4_dst_pitch;
    GFX_COLORMODE_T e_dst_cm;

    UINT32          ui4_width;
    UINT32          ui4_height;

    UINT8           ui1_alpha;
    // colorkey
    UINT32          b_key_sd_sel;
    UINT32          ui4_color_space_min;
    UINT32          ui4_color_space_max;
    // others
    // premultiply
    UINT32          u4PremultSrcRd;
    UINT32          u4PremultDstRd;
    UINT32          u4PremultDstWr;
    UINT32          u4Colorize;
    UINT32          ui4_color;
    UINT32          u4SrcPremultColor;
    UINT32          u4Xor;
} GFX_BITBLT_DFB_T;


typedef struct _GFX_STRETCH_BITBLT_DFB_T
{
    INT32           u4TicketId;
    VOID*           pv_src;
    INT32           i4_src_x;
    INT32           i4_src_y;
    UINT32          ui4_src_pitch;
    GFX_COLORMODE_T e_src_cm;

    VOID*           pv_dst;
    INT32           i4_dst_x;
    INT32           i4_dst_y;
    UINT32          ui4_dst_pitch;
    GFX_COLORMODE_T e_dst_cm;

    UINT32          ui4_width;
    UINT32          ui4_height;
    UINT32          ui4_dst_width;
    UINT32          ui4_dst_height;

    UINT8           ui1_alpha;
    // colorkey
    UINT32          b_key_sd_sel;
    UINT32          ui4_color_space_min;
    UINT32          ui4_color_space_max;
    // others
    // premultiply
    UINT32          u4PremultSrcRd;
    UINT32          u4PremultDstRd;
    UINT32          u4PremultDstWr;
    UINT32          u4Colorize;
    UINT32          u4SrcPremultColor;
    UINT32          u4Xor;
} GFX_STRETCH_BITBLT_DFB_T;

typedef struct _GFX_ALPHA_COMPOSITION_DFB_T
{
    INT32           u4TicketId;
    VOID*           pv_src;
    INT32           i4_src_x;
    INT32           i4_src_y;
    UINT32          ui4_src_pitch;
    GFX_COLORMODE_T e_src_cm;

    VOID*           pv_dst;
    INT32           i4_dst_x;
    INT32           i4_dst_y;
    UINT32          ui4_dst_pitch;
    GFX_COLORMODE_T e_dst_cm;

    UINT32          ui4_width;
    UINT32          ui4_height;
    // alpha compose
    UINT8           ui1_alpha;
    GFX_PD_RULE_T   e_rule;
    BOOL            b_rect_src_option;
    // colorkey
    UINT32          b_key_sd_sel;
    UINT32          ui4_color_space_min;
    UINT32          ui4_color_space_max;
    // premultiply
    UINT32          u4PremultSrcRd;
    UINT32          u4PremultDstRd;
    UINT32          u4PremultDstWr;
    // others
    UINT32          ui4_color;
    UINT32          u4Colorize;
    UINT32          u4SrcPremultColor;
    UINT32          u4Xor;
} GFX_ALPHA_COMPOSITION_DFB_T;


typedef struct _GFX_STRETCHCOMPOSE_DFB_T
{
    INT32           u4TicketId;
    VOID*           pv_src;
    INT32           i4_src_x;
    INT32           i4_src_y;
    UINT32          ui4_src_pitch;
    GFX_COLORMODE_T e_src_cm;

    VOID*           pv_dst;
    INT32           i4_dst_x;
    INT32           i4_dst_y;
    UINT32          ui4_dst_pitch;
    GFX_COLORMODE_T e_dst_cm;

    UINT32          ui4_width;
    UINT32          ui4_height;
    UINT32          ui4_dst_width;
    UINT32          ui4_dst_height;

    UINT8           ui1_ac_ar;
    GFX_PD_RULE_T   e_rule;
    BOOL            b_rect_src_option;
    GFX_OPTION_T    e_option;
    UINT32          ui4_rot_op;
    // colorkey
    UINT32          b_key_sd_sel;
    UINT32          ui4_color_space_min;
    UINT32          ui4_color_space_max;
    // others
    // premultiply
    UINT32          u4PremultSrcRd;
    UINT32          u4PremultDstRd;
    UINT32          u4PremultDstWr;
    UINT32          u4Colorize;
    UINT32          u4SrcPremultColor;
    UINT32          u4Xor;
    UINT32          u4Width_ForClip;
    UINT32          u4Height_ForClip;
    UINT32          u4Xoff_ForClip;
    UINT32          u4Yoff_ForClip;
	UINT32          u4XSrc_ForClip;
    UINT32          u4YSrc_ForClip;
    BOOL            b_clip_enable;
} GFX_STRETCHCOMPOSE_DFB_T;  
#endif


typedef union _GFX_CMD_BUF_U
{   
    GFX_FLIP_T                          rFlipCmd;
    GFX_FLIP_3D_T                       r3DFlipCmd;

    GFX_ALPHA_COMPOSITION_T             rAlphaCompositionCmd;
    GFX_FILL_T                          rFillCmd;
    GFX_BITBLT_T                        rBitbltCmd;
    GFX_TRANSPARENT_BITBLT_T            rTransparentBitbltCmd;
    GFX_TRANSPARENT_FILL_T              rTransparentFillCmd;
    GFX_REPLACE_COLOR_T                 rRplCmd;
    GFX_ALPHA_BLEND_T                   rAlphaBlendCmd;
    GFX_ALPHA_MUL_T                     rAlphaMulCmd;
    GFX_BITBLT_BASE_T                   rBitbltBaseCmd;
    GFX_STRETCH_BITBLT_T                rStretchBitbltCmd;
    GFX_ALPHAMAP_BITBLT_T               rAlphaMapBitbltCmd;
    GFX_YCBCR_TO_RGB_T                  rYc2RgbCmd;
    GFX_ROP_BITBLT_T                    rRopBitbltCmd;
    GFX_PLTBLT_T                        rPBitbltCmd;
    GFX_ROTATE_T                        rRotateCmd;
    
#if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8520)
    RLE_IMG_DIRECT_DECODE_T             rRleImgDirectDecodeCmd;
#endif

    GFX_ROTATE_STRETCH_ALPHACOMP_T      rRotateStretchAlphaCompCmd;
    GFX_BITBLT_MIRROR_FLIP_T            rBitbltMirrorFlipCmd;
    GFX_REFLECT_T                       rReflectCmd;

    GFX_FILL_BLEND_T                    rFillRectBlendCmd;
    GFX_COLORKEY_BITBLT_T               rColorKeyBitbltCmd;
    GFX_COLORKEY_STRETCH_BITBLT_T       rColorKeyStretchBitbltCmd;
    GFX_FILL_T                          rPremultFillCmd;
    GFX_PREMULT_BITBLT_T                rPremultBitbltCmd;
    GFX_PREMULT_ALPHA_COMPOSITION_T     rPremultAlphaComposeCmd;
    GFX_PREMULT_STRETCH_BITBLT_T        rPremultStretchBitbltCmd;
    GFX_PREMULT_STRETCH_BITBLT_BLEND_T  rPremultStretchBitbltBlendCmd;

    GFX_BITBLT_DFB_T                    rBlitDFB;
    GFX_STRETCH_BITBLT_DFB_T            rStretchBlitDFB;
    GFX_ALPHA_COMPOSITION_DFB_T         rComposeDFB;
    GFX_STRETCHCOMPOSE_DFB_T            rStretchComposeDFB;
} GFX_CMD_BUF_U;

typedef struct _GFX_BUFF_CMD_ITEM_T
{
    //GFX_BUFF_CMD_TYPE_T e_Type; // command type
    UINT32              u4CmdType;
    //GFX_DRV_FLUSH_TYPE  eFlushType; // command type 
    UINT32              u4FlushType;
    //UINT32 u4TimeStamp; // (reserved) time stamp of the command issued
    //UINT32 u4EstDuration; // (reserved) estimated duration of this command

    //GFX_APP_INSTANCEID_T e_app_id; // (reserved) module identifier which issues this command
    //GFX_HW_INSTANCEID_T  e_hw_id; // (reserved)
    //BOOL fg_OnScreen; // (reserved) if the drawing is on on-screen surface

    UINT32 u4CmdBuff[(sizeof(GFX_CMD_BUF_U) + 3)/4];
    UINT32                  u4Reserved[5];
} GFX_BUFF_CMD_ITEM_T;


typedef struct _GFX_LINUX_CMDBUF_T
{
    UINT32                  u4CmdbufOwner;
    UINT32                  u4GfxCmdMaxCount;
    UINT32                  u4GfxCmdBufId;           ///< the GFXCmd Buf Id
    UINT32                  u4GfxPriority;           ///< priority
    UINT32                  u4RdPoint;
    UINT32                  u4Reserved1[3];            // add for cache line
    UINT32                  u4GfxCurrPriority;       ///< current priority (priority will increase if not serviced)
    UINT32                  u4GfxCmdBufEvent;         ///< GFX Cmd Buf Event Handle
    UINT32                  u4GfxFlipEvent;         ///< GFX Flip Event Handle
    UINT32                  u4GfxHwInstId;           ///< GFX hardware instance id.
    UINT32                  u4GfxCmdBufState;         ///< Vg Cmd Buf state
    UINT32                  u4Reserved2[3];            // add for cache line
    UINT32                  u4WrPoint;
    UINT32                  u4Reserved3[7];            // add for cache line
    UINT32                  u4GfxCmdBufCompress;
    UINT32                  u4WaitDoneState;
    UINT32                  ui4WaitDoneSema;            ///< for multi-thread call waitdone()
    UINT32                  ui4CmdBufWRSema;            ///< for multi-thread call waitdone()
    UINT32                  u4Reserved4[4];
    BOOL                    fgWaitFlipDone;
    BOOL                    u4Reserved5[3];
    VOID*                   pvFlipEndBuf;
    VOID*                   pvFlipStartBuf;
    VOID*                   pvLastFlipBuf;
    VOID*                   pvLosslessFlipEndBuf;
    VOID*                   pvLosslessFlipStartBuf;
    VOID*                   pvLosslessLastFlipBuf;
    UINT32                  u4Reserved6[1];
    VOID*                   pvFlipEndBufR;
    VOID*                   pvFlipStartBufR;
    VOID*                   pvLastFlipBufR;
    VOID*                   pvLosslessFlipEndBufR;
    VOID*                   pvLosslessFlipStartBufR;
    VOID*                   pvLosslessLastFlipBufR;
    UINT32                  u4Reserved7[2];
} GFX_LINUX_CMDBUF_T;

// used for mmap
typedef struct _GFX_DRV_CMDBUF_T
{
    GFX_LINUX_CMDBUF_T      *prGfxDrvCmdBuf;
    VOID                    *prPrevCmdBuf;          ///< previous Cmd Buf
    VOID                    *prNextCmdBuf;          ///< Next Cmd Buffer
    UINT32                  u4Private;
    UINT32                  ui4GfxCmdBufSema;          // /< GFX Cmd Buf Same
#if (CONFIG_CHIP_VER_CURR == CONFIG_CHIP_VER_MT8560)
    GFX_BUFF_CMD_TYPE_T     u4LastCmdGroup;
    UINT32                  u4Reserved[2];
#else
    UINT32                  u4Reserved[3];
#endif
} GFX_DRV_CMDBUF_T;

typedef struct _GFX_CMD_BUFF_T
{
#if CONFIG_SYS_MEM_PHASE3
    UINT32          ui4_gfx_ticket_offset;
    HANDLE_T        h_MemHandle;
#endif
    UINT32          u4CmdbufOwner;
    UINT32          ui4_gfx_ticketid;
    GFX_DRV_CMDBUF_PRIORITY e_cmdbuff_priority; 
} GFX_CMD_BUFF_T;
 
typedef struct _GFX_SYNC_MMU_T
{
    VOID*           pv_mem;
    UINT32          u4Size;
} GFX_SYNC_MMU_T;

#endif
